// Lamp.cpp: implementation of the CLamp class.
//
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include "Lamp.h"
using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLamp::CLamp(int w) 
{
	b_ptr = new CBulb(w);
	sw_ptr = new CSwitch;
}

CLamp::~CLamp()
{
	delete b_ptr;
	delete sw_ptr;
}

//////////////////////////////////////////////////////////////////////
// Lamp On
//////////////////////////////////////////////////////////////////////
void CLamp::on() 
{
	sw_ptr->close();
	b_ptr->on();
}

//////////////////////////////////////////////////////////////////////
// Lamp off
//////////////////////////////////////////////////////////////////////
void CLamp::off()
{
	sw_ptr->open();
	b_ptr->off();
}

//////////////////////////////////////////////////////////////////////
// Identify lamp condition
//////////////////////////////////////////////////////////////////////
void CLamp::identify() 
{
	if (sw_ptr->get_state() == 1)
	{
		cout << "lamp is on" << endl;
	}
	else
	{
		cout << "lamp is off" << endl;
	}
}

//////////////////////////////////////////////////////////////////////
// return lamp power usage
//////////////////////////////////////////////////////////////////////
int CLamp::getpower()
{
	if(sw_ptr->get_state() == 1)
	{
		return b_ptr->get_power();
	}
	else
	{
		return 0;
	}
}

//////////////////////////////////////////////////////////////////////
// change bulb
//////////////////////////////////////////////////////////////////////
void CLamp::change_bulb(int w)
{
	cout << "Replacing " << b_ptr->get_power() << " watt bulb";
	delete b_ptr;
	b_ptr = new CBulb(w);
	cout << " with " << w << " watt bulb" << endl;
}